using System.Drawing;
using System.Numerics;

namespace SlatedGameToolkit.Framework.Utilities
{
    public static class RectangleUtils
    {
        public static RectangleF MultiplyBy(this RectangleF rectangle, float multiplier) {
            RectangleF rect = rectangle;
            rect.X *= multiplier;
            rect.Y *= multiplier;
            rect.Width *= multiplier;
            rect.Height *= multiplier;
            return rect;
        }

        public static bool IsOverlapping(this RectangleF a, RectangleF b) {
            if (a.Left > b.Right) return false;
            if (a.Right < b.Left) return false;
            if (a.Bottom > b.Top) return false;
            if (a.Top < b.Bottom) return false;
            return true;
        }

        public static bool IsWithin(this RectangleF rect, Vector2 vector) {
            if (vector.X > rect.Right) return false;
            if (vector.X < rect.Left) return false;
            if (vector.Y > rect.Top) return false;
            if (vector.Y < rect.Bottom) return false;
            return true;
        }
    }
}